<?php

//####################################################################
// Active PHP Bookmarks - lbstone.com/apb/
//
// Filename:    apb.php
// Authors:     L. Brandon Stone (lbstone.com)
//              Nathanial P. Hendler (retards.org)
//				Martin Gecks (gecks.net)
//
// 2009-03-26	costumisation [MG]
// 2009-03-25	Support for Globals OFF [MG]
// 2003-03-11   Added security check. [LBS]
// 2002-02-07   Rearranged the order of things, added some
//              additional comments. [LBS]
// 2001-09-04   Starting on version 1.0 [NPH] [LBS]
//
//####################################################################

//////////////////////////////////////////////////////////////////////
// Security check.
//////////////////////////////////////////////////////////////////////

if (isset($_COOKIE["DOCUMENT_ROOT"]) ||
    isset($_POST["DOCUMENT_ROOT"]) ||
    isset($_GET["DOCUMENT_ROOT"]))
{ exit(); }

//////////////////////////////////////////////////////////////////////
// Database configuration.
//////////////////////////////////////////////////////////////////////

// Change these vars so that you can connect to your database.
$GLOBALS['apb_host']     = "";
$GLOBALS['apb_database'] = "";
$GLOBALS['apb_username'] = "";
$GLOBALS['apb_password'] = "";

// If you would like to set your database variables from an external
// file, link to that from here.
//include("/var/www/apb_db_config.php");

//////////////////////////////////////////////////////////////////////
// Paths and URLs.
//////////////////////////////////////////////////////////////////////

// Change the apb_dir_name, if you want the program to run somewhere other
// than the "bookmarks", directory.  By default this value is 'bookmarks/'.
// If you want to run APB from 'http://www.yoursite.com/bm/', just change
// this value to 'bm/'.
$GLOBALS['apb_dir_name'] = 'bookmarks/';

// There is usually no reason to change these.
$GLOBALS['apb_url']   = 'http://' . $_SERVER['HTTP_HOST'] . '/' . $GLOBALS['apb_dir_name'];
$GLOBALS['home_url']  = $GLOBALS['apb_url'];
$GLOBALS['apb_path']  = $_SERVER['DOCUMENT_ROOT'] . '/' . $GLOBALS['apb_dir_name'];
$GLOBALS['log_path']  = $GLOBALS['apb_path'] . 'apb.log';
$GLOBALS['view_group_path'] = $GLOBALS['apb_url'] . "view_group.php";
$GLOBALS['lang_path']  = $GLOBALS['apb_path'] . "language/";
$GLOBALS['css_path'] = $GLOBALS['apb_url'] . "templates/";

//////////////////////////////////////////////////////////////////////
// Global settings.
//////////////////////////////////////////////////////////////////////

// Change these at your own risk.  (These will be documented after
// they've been fully tested.)
$GLOBALS['template']  = 'default';
$GLOBALS['auth_type'] = 'cookie';  	// 'httpd' or 'cookie'
$GLOBALS['limit']     = 5;
$GLOBALS['debug']     = 0;

//////////////////////////////////////////////////////////////////////
// Load the language file
//////////////////////////////////////////////////////////////////////

include_once($GLOBALS['lang_path']."english.php");		// Edit to german.php for german language

//////////////////////////////////////////////////////////////////////
// Load the program libraries.
//////////////////////////////////////////////////////////////////////

include_once($GLOBALS['apb_path']."apb_common.php");

//////////////////////////////////////////////////////////////////////
// Choose the styles.
//////////////////////////////////////////////////////////////////////

$GLOBALS['cssfile'] = "apb.css";			// The name of the desired CSS-File

//////////////////////////////////////////////////////////////////////
// User Configuration.
//////////////////////////////////////////////////////////////////////

$GLOBALS['pagetitle'] = "Active PHP Bookmarks";	// The Title of the Webpage
$GLOBALS['showtitle'] = 1; 					// Set to 0 if you want to hide the Title
$GLOBALS['email'] = "yourname@yourdomain.com";	// The email-adress for breakin-attempt-notifications
$GLOBALS['allow_edit_mode'] = 1;			// Set to 0 if nobody is allowed to edit bookmarks
$GLOBALS['childgroups'] = 3 ;				// The number of childgroups to dislpay in HOME before ... is printed
$GLOBALS['showsearch']	= 1 ;				// Set to 0 if the searchbox is only allowed for users who are logged in
$GLOBALS['searchinfoot'] = 1 ;				// Set to 0 if the searchbox shall not be showed in the foot
$GLOBALS['searchinright'] = 0 ;				// Set to 1 if the searchbox shall not be showed in the right (set both to 0 if no one is allowed to see the searchbox)
$GLOBALS['showlogin']	= 1 ;				// Set to 0 if everybody is allowed to login directly
$GLOBALS['helpinfoot'] = 1 ;				// Set to 0 if the help-button shall not be showed in the foot for users who are not logged in
$GLOBALS['showhome'] = 1 ;					// Set to 0 if you want to hide the bookmarks home button for users who are not logged in
$GLOBALS['daily_browsing_public'] = 0;		// Set to 1 if every visitor shall be able to see the daily browsed links
$GLOBALS['showdisclaimer'] = 1 ;			// Set to 0 if you do not want to show the disclaimer message
$GLOBALS['disclaimer'] = "Please read our <a href='../disclaimer.htm' target='_self'>disclaimer</a>.";

?>